if (not nUI) then return end
-- if nUI_Version > "5.03.00" then return end
local hud = {
	silent = false,
	verbose = true,
	huds = {
		brohud = "broHUD",
		dhud3 = "DHUD3",
		icehud = "IceHUD",
		metahud = "MetaHud",
		microhud = "MicroHUD",
		texthud = "TextHUD",
		wdahud = "wDaHud",
	},
	hudmod = {},
}


nUI_Config_HUD = hud

if (not hud.frame) then
	hud.frame = CreateFrame("Frame")
end

local function setHUDLayout()
	nUI_Options["hud_layout"] = "nUI_HUDLayout_NoHUD"
end
	
local function setHUD()
	if (hud.verbose and not hud.silent) then DEFAULT_CHAT_FRAME:AddMessage("nUI: Config [HUD] has detected " .. hud.hudmod.name .. ".") end
end
	
local function initSlashCommands()
	if (hud.verbose and not hud.silent) then DEFAULT_CHAT_FRAME:AddMessage("nUI: Config [HUD] is initializing slash commands") end 
end

local function initConfig()
	setHUDLayout()
end

local function detectHUD()
	local hudname = ""
	local hudtitle = ""
	local hudversion = ""
	local hudauthor = ""
	
	for k,v in pairs(hud.huds) do 
		
		if (IsAddOnLoaded(v)) then
			hudtitle = GetAddOnMetadata(v, "Title")
			hudversion = GetAddOnMetadata(v, "Version")
			hudauthor = GetAddOnMetadata(v, "Author")

			hud.hudmod = {
				name = v,
				title = hudtitle,
				version = hudversion,
				author = hudauthor,
			}
			
			break
		end
	end
	

end

local function OnEvent(self, event, ...)
	if (event == "VARIABLES_LOADED") then
		hud.frame:UnregisterEvent("VARIABLES_LOADED")
		if (not hud.icehud) then return end
		initSlashCommands()
		initConfig()

	elseif (event == "ADDON_LOADED") and (arg1 == "nUI_Config_HUD") then
		if (not hud.silent) then DEFAULT_CHAT_FRAME:AddMessage("nUI: Config [HUD] loaded.") end
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "broHUD") then
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "DHUD3") then
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "IceHUD") then
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "MetaHud") then
		detectHUD()

		elseif (event == "ADDON_LOADED") and (arg1 == "MicroHUD") then
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "TextHUD") then
		detectHUD()

	elseif (event == "ADDON_LOADED") and (arg1 == "wDaHud") then
		detectHUD()
	
	elseif (event == "PLAYER_LOGIN") then
		hud.frame:UnregisterEvent("PLAYER_LOGIN")
		if (hud.hudmod.name) then setHUD() end
	
	end
end

hud.frame:SetScript("OnEvent", OnEvent)
hud.frame:RegisterEvent("ADDON_LOADED")
hud.frame:RegisterEvent("VARIABLES_LOADED")
hud.frame:RegisterEvent("PLAYER_LOGIN")
